/*
 * Copyright (C) 2012, Eric Wong <normalperson@yhbt.net>
 * License: GPLv3 or later (see COPYING for details)
 */

static inline struct mog_fd * mog_fd_of(void *as_obj)
{
	uintptr_t as_addr = (uintptr_t)as_obj;

	return (struct mog_fd *)(as_addr - offsetof(struct mog_fd, as));
}


/* used to validate a mog_fd is never in two queues at once */
static inline void mog_fd_check_in(struct mog_fd *mfd)
{
	assert(mog_sync_add_and_fetch(&mfd->in_queue, 1) == 1 &&
	       "in_queue counter off (check in)");
}

/* used to validate a mog_fd is never in two queues at once */
static inline void mog_fd_check_out(struct mog_fd *mfd)
{
	assert(mog_sync_sub_and_fetch(&mfd->in_queue, 1) == 0 &&
	       "in_queue counter off (check out)");
}
